/*
 *
 * This file is part of the Percentile Noise Estimation algorithm.
 *
 * Copyright(c) 2012 Miguel Colom.
 * miguel.colom@cmla.ens-cachan.fr
 *
 * This file may be licensed under the terms of of the
 * GNU General Public License Version 2 (the ``GPL'').
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the GPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the GPL along with this
 * program. If not, go to http://www.gnu.org/licenses/gpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

#ifndef CFFT_H
#define	CFFT_H

#include <fftw3.h>

class CFFT {
public:
  CFFT(int Nx, int Ny);
  virtual ~CFFT();
  fftwf_complex *get_buffer_in();
  fftwf_complex *get_buffer_out();
  fftwf_complex *get_buffer_tmp();
  void FFT_forward();
  void FFT_backward();
private:
  int Nx;
  int Ny;
  fftwf_complex *FFT_in;
  fftwf_complex *FFT_out;
  fftwf_complex *FFT_tmp;
  fftwf_plan p_forward;
  fftwf_plan p_backward;
};

#endif	/* CFFT_H */

